<?php 
$controller = 'Category';
$action = '';
if(isset($_POST['action'])){
    $action = $_POST['action'];
    if (isset($_POST['id'])) {$id = $_POST['id'];}
}elseif(isset($_GET['action'])){
    $action = $_GET['action'];
    if (isset($_GET['id'])) {$id = $_GET['id'];}
}
include $_SERVER["DOCUMENT_ROOT"].'/app/include/bootstrap.php';

$_form = new CategoriaForm();
$_categoria = new CategoriaEntity();
$_listaCategorias = $_categoria->getListaCategorias();

switch($action){
    case 'insert':
        $_form->populate($_POST);
        if($_form->isValid()){
            $_categoria->setOptions($_POST);
            $result = $_categoria->save($_categoria->getOptions());
            if($result){
                $flashmessenger->addMessage(array('success'=>'Genial !! La Categoria ha sido registrado exitosamente.'));
                header('Location: Category.php');
            }else{
                $flashmessenger->addMessage(array('danger'=>'Oops !!, algo salio mal al intentar registrar Categoria. Intenta nuevamente o contacta a tu proveedor de sistemas.'));
            }
        }else{
            $_listaCategorias = $_categoria->getListaCategorias();
            $vista = 'Categoria.php';
            include $root.'/View/Template.php';
        }
        break;
   
    case 'edit':
        if($_GET){$_categoriaData = $_categoria->getById($id);}
        if($_POST){$_categoriaData = $_POST;}
        
        $_form->setActionController('edit');
        $_form->setId($id);
        $_form->populate($_categoriaData);
        
        $_listaCategorias = $_categoria->getListaCategorias();
        
        if(isset($_POST['id'])){
            if($_form->isValid()){
                $_categoria->setOptions($_categoriaData);
                $result = $_categoria->update($id,$_categoria->getOptions()); //no tengo id porque viene de post
                if($result){
                    $flashmessenger->addMessage(array('success'=>'Estupendo !! La Categoria ha actualizado exitosamente.'));
                    header("Location: Category.php?action=edit&id=$id");
                }else{
                    $flashmessenger->addMessage(array('danger'=>'Oops !!, algo salio mal al intenta actualizar la Lista de Pago. Intenta nuevamente o contacta a tu proveedor de sistemas.'));
                }       
            }else{
                $vista = 'Categoria.php';
                include $root . '/View/Template.php';
            }
        }else{
            $vista = 'Categoria.php';
            include $root . '/View/Template.php';
        }        
        break;
    
    case 'delete': 
        if(!$_categoria->isUsedInRecord($id)){
            if($_categoria->delete($id)){
                $flashmessenger->addMessage(array('success'=>'Hecho !! La Categoria fue eliminada satisfactoriamente.'));                
            }
        }else{
            $message = 'Oops !!, esta Categoria no puede ser eliminada, esta siendo utilizada en almenos un registro.';
            $flashmessenger->addMessage(array('info'=>$message));
        }
        header('Location: Category.php');
        break;    
    
    default:
        $_listaCategorias = $_categoria->getListaCategorias();
        $vista = 'Categoria.php';
        include $root.'/View/Template.php';
}